	MAIN	"MAIN",#80
;---------------------------------;
; BASIC	INPUT OUTPUT SYSTEM (4*8) ;	
;---------------------------------;	
;					
;INP_W:	   input word			
;	   HL <- word			
;	   DE <- XY			
;	   HL =	word			
;	   F: =C  - error		
;	      =NC - ok			
;INP_B:	   input byte			
;	   L  <- byte			
;	   DE <- XY			
;	   HL <- byte
;	   F: =C  - error		
;	      =NC - ok			
;INP:	   input string			
;	   HL <- address of input	
;	   DE <- XY			
;	   A  <- length	input string	
;INCHR:	   input char			
;	   A = code of char		
;	   (BREAK) <- #C9 - break off	
;		   <- 0	  - break on	
;PRL:	   CALL	PRL			
;	   DEFB	"...",0			
;PRT_B:	   print byte -> L (in 3 positions)
;PRT_B4:	    -//-       4
;PRT_B5:	    -//-       5
;PRT_W:	   print word -> HL    5
;PRNUM:	   print number
;	   HL <- number
;	   A  <- number	positions
;PRT_B_L:  print byte -> L  (with left)	(in 3 positions)
;PRT_W_L:  print word -> HL    -//-	    5
;PRNUML:   print number	       -//-
;	   HL <- number
;	   A  <- number	positions
;PRT:	   print of text
;	   HL <- address of text
;	   CTRL	chars:
;		    0 -	end of text
;	   #FF,<ATTR> -	set attribute
;	   22,<Y>,<X> -	cursor positing
;		   13 -	scroll of 5(6) down lines and
;			setting	cursor in position X=3,Y=23
;PRC:	   A - char (A=13 - analog 13 in PRT)
;PRCSP:	   print space
;BPRT:	   print of text (if char<32 then char="")
;	   HL <- address of text
;	   B  <- lenght
;NUMSTR:   number to string
;	   HL <- number
;	   A  <- number	positions
;	   HL =	address	of string
;W_STR:	   word	to string
;	   HL <- word
;	   HL =	address	of string
;	   A  =	5
;B_STR:	   byte	to string
;	   L  <- byte
;	   HL =	address	of string
;	   A  =	3
;STRNUM:   string to number
;	   IX <- address of string
;	   HL =	number
;	   F: =C  - error
;	      =NC - ok
;STRNUM0:  analog STRNUM, but in begin and in end
;	   of string spaces no may be
;MUL:	   DE=DE*BC
;DIV:	   BC=DE=DE/HL
;
;INP_B
;	PUSH	DE
;	CALL	B_STR
;	POP	DE
;	JR	INP_WB
;
INP_W
	PUSH	DE
	CALL	W_STR
	POP	DE
INP_WB
	CALL	INP
	PUSH	IX
	LD	IX,BUFSTR
	CALL	STRNUM
	POP	IX
	RET 
;
INP
	LD	(BEGAT),DE
	LD	(CULEN),A
	LD	(CULEN2),A
	LD	(INPAD),HL
	LD	DE,BUFINP
	PUSH	DE
	LD	(BINP),DE
	LD	C,A
	LD	B,0
	LDIR 
	POP	HL
	LD	DE,BCNAME
	LD	C,A
	LD	B,0
	LDIR 
	CALL	PRL
CURSXY	DEFB	22,0,0,0
ATCURS	EQU	$-3
BEGAT	EQU	$-3
BEGX	EQU	$-2
	LD	A,(BEGX)
	LD	(XBEG),A
	CALL	INPUTPRT
	LD	A,(XBEG)
	LD	(ATX),A
	XOR	A
	LD	(BREAK),A
RKEY
	CALL	CURS
	CALL	INCHR
	LD	HL,TKEYINP
FIND2
	BIT	7,(HL)
	JR	NZ,PRKEY
	CP	(HL)
	INC	HL
	JR	Z,SELECT2
	INC	HL
	INC	HL
	JR	FIND2
SELECT2
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	JP	(HL)
;
TKEYINP
	DEFB	CS1
	DEFW	C_RETNAME
	DEFB	CS2
	DEFW	C_INS
	DEFB	CS5
	DEFW	C_LEFT
	DEFB	CS6
	DEFW	C_BEGIN
	DEFB	CS7
	DEFW	C_END
	DEFB	CS8
	DEFW	C_RIGHT
	DEFB	CS9
	DEFW	C_DEL
	DEFB	CS0
	DEFW	C_BSP
	DEFB	EXTEND
	DEFW	C_ALL
	DEFB	ENTER
	DEFW	C_ENTER
	DEFB	#FF
;
PRKEY
	CP	32
	JR	C,RKEY
	LD	(CHAR),A
	CALL	L_
	JR	Z,RKEY
	LD	A,(CHAR)
	LD	HL,0
BINP	EQU	$-2
	LD	(HL),A
	INC	HL
	LD	(BINP),HL
	CALL	PRC
RKEY1
	JR	RKEY
;
C_RETNAME
	CALL	LDC_CULEN
	LD	HL,BCNAME
	LD	DE,BUFINP
	LDIR 
	JR	INPRKEY
;
C_INS
	CALL	L_
	JR	Z,RKEY
	LD	HL,BUFINP
	CALL	LDC_CULEN
	ADD	HL,BC
	DEC	HL
	EX	DE,HL
	CALL	INRIGHT
	LD	C,L
	LD	B,H
	EX	DE,HL
	LD	E,L
	LD	D,H
	DEC	HL
	LDDR 
	LD	HL,(BINP)
SPINPRKEY
	LD	(HL)," "
INPRKEY
	CALL	INPUTPRT
	JR	RKEY1
;
C_LEFT
	CALL	F_
	JR	Z,RKEY1
	CALL	C_LEFT2
	JR	RKEY1
;
C_LEFT2
	LD	HL,ATX
	DEC	(HL)
	LD	HL,(BINP)
	DEC	HL
	LD	(BINP),HL
	RET 
;
C_BEGIN
	LD	HL,BUFINP
	LD	(BINP),HL
	LD	A,(XBEG)
	JR	ATXA
;
C_END
	CALL	LDC_CULEN
	LD	HL,BUFINP
	ADD	HL,BC
	LD	(BINP),HL
	LD	A,(XBEG)
	ADD	A,C
ATXA
	LD	(ATX),A
RKEY2
	JR	RKEY1
;
C_RIGHT
	CALL	L_
	JR	Z,RKEY1
	LD	HL,ATX
	INC	(HL)
	LD	HL,(BINP)
	INC	HL
	LD	(BINP),HL
	JR	RKEY2
;
C_DEL
	CALL	L_
	JR	Z,RKEY2
	DEC	A
	CP	(HL)
	JR	Z,RKEY2
	CALL	INRIGHT
	LD	C,L
	LD	B,H
	DEC	BC
	LD	HL,(BINP)
	LD	E,L
	LD	D,H
	INC	HL
	LDIR 
	LD	HL,BUFINP
	CALL	LDC_CULEN
	ADD	HL,BC
	DEC	HL
	JP	SPINPRKEY
;
C_BSP
	CALL	F_
	JR	Z,RKEY2
	CALL	C_LEFT2
	LD	HL,(BINP)
	LD	A," "
	LD	(HL),A
	CALL	PRC
	LD	HL,ATX
	DEC	(HL)
	JR	RKEY2
;
C_ALL
	XOR	A
	OR	A
	JR	Z,RKEY2
	LD	A,""
	JP	PRKEY
;
C_ENTER
	LD	HL,BUFINP
	LD	DE,0
INPAD	EQU	$-2
	LD	BC,0
CULEN2	EQU	$-2
	LDIR 
	RET 
;
F_
	LD	A,(XBEG)
	LD	HL,ATX
	CP	(HL)
	RET 
;
L_
	LD	A,(CULEN)
	LD	HL,XBEG
	ADD	A,(HL)
	LD	HL,ATX
	CP	(HL)
	RET 
;
INRIGHT
	CALL	LDC_CULEN
	LD	HL,BUFINP
	ADD	HL,BC
	LD	BC,(BINP)
	OR	A
	SBC	HL,BC
	RET 
;
LDC_CULEN
	LD	BC,(CULEN)
	LD	B,0
	RET 
;
INPUTPRT
	LD	A,(ATX)
	EX	AF,AF'
	LD	A,0
XBEG	EQU	$-1
	LD	(ATX),A
	LD	HL,BUFINP
	LD	B,0
CULEN	EQU	$-1
	CALL	BPRT
	EX	AF,AF'
	LD	(ATX),A
	RET 
;
BPRT
	LD	A,(HL)
	INC	HL
	PUSH	HL
	PUSH	BC
	CP	#20
	JR	C,ERRCH
	CP	#81
	JR	C,NOERRCH
ERRCH
	LD	A,""
NOERRCH
	CALL	PRC
	POP	BC
	POP	HL
	DJNZ	BPRT
	RET 
;
INCHR
	EI 
	XOR	A
	LD	(23560),A
	LD	HL,1
NEXTIN
	LD	(TIME2),HL
	CALL	BREAK
	HALT 
	HALT 
	LD	B,3
LPLP
	DJNZ	LPLP
	LD	A,(23560)
	OR	A
	JR	NZ,RESETCURS
	LD	HL,0
TIME2	EQU	$-2
	DEC	HL
	LD	A,L
	OR	H
	JR	NZ,NEXTIN
	CALL	CURS
	LD	HL,5
	JR	NEXTIN
RESETCURS
	PUSH	AF
	PUSH	IX
	CALL	RESCURS
	LD	HL,#1E
	LD	DE,#1E
	CALL	#3B5
	POP	IX
	POP	AF
	RET 
;
RESCURS
	LD	A,0
CURSOR	EQU	$-1
	OR	A
	CALL	NZ,CURS
	RET 
;
CURS
	LD	A,(CURSOR)
	CPL 
	LD	(CURSOR),A
CURS2
	LD	HL,(DYLINE)
	LD	A,(ATX)
	LD	C,A
	SRL	A
	ADD	A,L
	LD	L,A
	LD	A,C
	RRA 
	SBC	A,A
	XOR	#F0
	LD	C,A
	LD	B,8
NEXTB
	LD	A,(HL)
	XOR	C
	LD	(HL),A
	INC	H
	DJNZ	NEXTB
	RET 
;
BREAK
	DEFB	0
	LD	B,128
LPBREAK
	LD	A,#7F
	IN	A,(#FE)
	RRA 
	RET	C
	LD	A,#FE
	IN	A,(#FE)
	RRA 
	RET	C
	DJNZ	LPBREAK
	CALL	RESCURS
	LD	A,#AF
	LD	(C_ALL),A
	XOR	A
	OUT	(#FE),A
	RST	8
	DEFB	#73
;
PRL
	POP	HL
	CALL	PRT
	JP	(HL)
;
PRT_B_L
	LD	H,0
	LD	A,3
	JR	PRNUML
PRT_W_L
	LD	A,5
PRNUML
	CALL	NUMSTR
PRNUML0
	LD	A," "
PRNUML2
	CP	(HL)
	JR	NZ,PRT
	EXX 
	LD	HL,BUFSTR+1
	LD	DE,BUFSTR
	LD	BC,4
	LDIR 
LDNOP
	NOP 
	LD	(DE),A
	EXX 
	JR	PRNUML2
;
PRT_B
	LD	H,0
	LD	A,3
	JR	PRNUM
PRT_B4
	LD	H,0
	LD	A,4
	JR	PRNUM
PRT_B5
	LD	H,0
PRT_W
	LD	A,5
PRNUM
	CALL	NUMSTR
;
PRT
	LD	A,(HL)
	INC	HL
	OR	A
	RET	Z
	CP	22
	JR	Z,GO_AT
	CP	#FF
	JR	Z,NEW_ATTR
	EXX 
	CALL	PRC
	EXX 
	JR	PRT
NEW_ATTR
	LD	A,(HL)
	INC	HL
	LD	(ATTR),A
	JR	PRT
GO_AT
	LD	D,(HL)
	INC	HL
	LD	E,(HL)
	INC	HL
	PUSH	HL
	LD	(ATX),DE
	LD	E,0
	CALL	SCRADDR
	LD	(DYLINE),HL
	CALL	ATTRADDR
	LD	(DYATTR),HL
	POP	HL
	JR	PRT
;
PRCSP
	LD	A," "		    
PRC
	CP	13
	JR	Z,ENTERCHR
	CP	1
	JR	NZ,NODELCH
	LD	A,""
NODELCH
	LD	(CHAR),A
	LD	A,(ATX)
	LD	B,A
	SRL	A
	LD	C,A
	LD	HL,0
DYATTR	EQU	$-2
	LD	A,L
	ADD	A,C
	LD	L,A
	LD	(HL),7
ATTR	EQU	$-1
	LD	DE,0
DYLINE	EQU	$-2
	LD	A,E
	ADD	A,C
	LD	E,A
	LD	A,B
	RRA 
	SBC	A,A
	XOR	#F0
	LD	(LMS),A
	CPL 
	LD	(SMS),A
	LD	HL,FONT
CHAR	EQU	$-2
	LD	B,8
NEXTOUT
	LD	A,(HL)
	AND	0
LMS	EQU	$-1
	LD	C,A
	LD	A,(DE)
	AND	0
SMS	EQU	$-1
	OR	C
	LD	(DE),A
	INC	H
	INC	D
	DJNZ	NEXTOUT
	LD	HL,ATX
	INC	(HL)
	RET 
ENTERCHR
	LD	B,4
LINESCMDL EQU	$-1
	CALL	#E00
	XOR	A
	LD	(ATX),A
	LD	HL,#50E0
	LD	(DYLINE),HL
	LD	HL,#5AE0
	LD	(DYATTR),HL
	RET 
;
ATX	EQU	#6012
ATY	EQU	#6013
;
W_STR
	LD	A,5
;	JR	WB_STR
;B_STR
;	LD	H,0
;	LD	A,3
WB_STR
	PUSH	AF
	PUSH	AF
	LD	A,"#"
	LD	(SPACECH),A
	POP	AF
	CALL	NUMSTR
	CALL	SETSPCH
	POP	AF
	RET 
;
NUMSTR
	LD	(DXPRT),A
	LD	A," "
HEXDECF	EQU	$-1
	CP	" "
	JR	Z,DECSTR
	PUSH	IX
	LD	IX,CHARS
	LD	DE,ENDBUFSTR
	CALL	BYTESTRL
	CALL	BYTESTRH
	LD	L,H
	CALL	BYTESTRL
	CALL	BYTESTRH
	EX	DE,HL
	LD	A,(SPACECH)
	CP	"#"
	JR	Z,ENDNUMSTR
	INC	HL
	LD	B,3
ENDDECSTR
	LD	A,"0"
LPNHS
	CP	(HL)
	JR	NZ,ENDNUMSTR
	LD	(HL)," "
	INC	HL
	DJNZ	LPNHS
ENDNUMSTR
	LD	HL,ENDBUFSTR+1
	LD	BC,0
DXPRT	EQU	$-2
	OR	A
	SBC	HL,BC
	LD	A,(HEXDECF)
	CP	" "
	RET	Z
	LD	(HL)," "
SPACECH	EQU	$-1
	POP	IX
	RET 
;
DECSTR
	LD	DE,BUFSTR
	PUSH	DE
	LD	BC,10000
	CALL	DECDIV
	LD	BC,1000
	CALL	DECDIV
	LD	BC,100
	CALL	DECDIV
	LD	BC,10
	CALL	DECDIV
	LD	A,L
	ADD	A,"0"
	LD	(DE),A
	POP	HL
	LD	B,4
	JR	ENDDECSTR
;
DECDIV
	XOR	A
	DEC	A
DECDIV1
	INC	A
	SBC	HL,BC
	JR	NC,DECDIV1
	ADD	HL,BC
	ADD	A,"0"
	LD	(DE),A
	INC	DE
	RET 
;
BYTESTRH
	LD	A,#F0
	AND	L
	RRA 
	RRA 
	RRA 
	RRA 
	JR	BYTESTR
BYTESTRL
	LD	A,#0F
	AND	L
BYTESTR
	LD	(DXNUM),A
	LD	A,(IX)
DXNUM	EQU	$-1
	LD	(DE),A
	DEC	DE
	RET 
;
STRNUM
	LD	A,(IX)
	CP	" "
	JR	NZ,SN1
	INC	IX
	JR	STRNUM
SN1
	PUSH	IX
SN2
	LD	A,(IX)
	OR	A
	JR	Z,SN3
	INC	IX
	JR	SN2
SN3
	DEC	IX
	LD	A,(IX)
	CP	" "
	JR	NZ,SN4
	LD	(IX),0
	JR	SN3
SN4
	POP	IX
;
STRNUM0
	LD	A,(IX)
	OR	A
	JR	Z,ERRNUM
	CP	"#"
	LD	A,10
	JR	NZ,SETMN
	LD	A,16
	INC	IX
SETMN
	LD	(DECHEX),A
	LD	HL,0
LOOPNUM
	LD	A,(IX)
	INC	IX
	OR	A
	RET	Z
	CALL	CHRNUM
	JR	C,ERRNUM
	PUSH	HL
	LD	HL,DECHEX
	CP	(HL)
	POP	HL
	JR	C,ADDITION
	JR	NZ,ERRNUM
ADDITION
	EX	AF,AF'
	EX	DE,HL
	LD	BC,0
DECHEX	EQU	$-2
	CALL	MUL
	EX	AF,AF'
	LD	L,A
	LD	H,0
	ADD	HL,DE
	JR	LOOPNUM
ERRNUM
	LD	A,2
	OUT	(#FE),A
ERRCHR
	SCF 
	RET 
;
CHRNUM
	CP	"a"
	JR	C,CHRNUM2
	CP	"g"
	JR	NC,ERRCHR
	SUB	"a"-10
	RET 
CHRNUM2
	CP	"G"
	JR	NC,ERRCHR
	CP	"A"
	JR	C,CHRNUM3
	SUB	"A"-10
	RET 
CHRNUM3
	CP	"0"
	JR	C,ERRCHR
	CP	":"
	JR	NC,ERRCHR
	SUB	"0"
	RET 
;
CHARS	EQU	#6500		;DEFB	 "0123456789ABCDEF"
BUFSTR	EQU	#6510		;DEFS	 6
ENDBUFSTR EQU	#6514		;EQU	 $-2
;
MUL
	EX	DE,HL
	LD	DE,0
	LD	A,16
MUL1
	RR	B
	RR	C
	JR	NC,MUL2
	EX	DE,HL
	ADD	HL,DE
	EX	DE,HL
MUL2
	ADD	HL,HL
	DEC	A
	JR	NZ,MUL1
	RET 
;
DIV
	LD	BC,0
	LD	A,1
DIV1
	BIT	7,H
	JR	NZ,DIV2
	ADD	HL,HL
	INC	A
	JR	DIV1
DIV2
	EX	DE,HL
DIV4
	OR	A
	SBC	HL,DE
	CCF 
	JR	C,DIV3
	ADD	HL,DE
	OR	A
DIV3
	RL	C
	RL	B
	RR	D
	RR	E
	DEC	A
	JR	NZ,DIV4
	LD	E,C
	LD	D,B
	RET