	MAIN	"MAIN",#80
;
CALC
	CALL	PRL
	DEFB	22,23,3,#FF,71,"Calculator",13,0
	LD	A,(HEXDECF)
	LD	(HDF),A
	CALL	CLRBCALC
LPCALC
	LD	A,0
HDF	EQU	$-1
	LD	(HEXDECF),A
	LD	HL,OPER1
	LD	DE,OPER1+1
	LD	(HL),0
	LD	BC,11
	LDIR 
	LD	A,11
	LD	DE,23
	LD	HL,BCALC
	PUSH	HL
	CALL	INP
	POP	HL
	LD	DE,OPER1
	CALL	OPERAND
	LD	A,(HL)
	LD	(OPERATION),A
	JR	NC,ERRCALC
	INC	HL
	CP	"="
	JR	Z,CALC3
	LD	DE,OPER2
	CALL	OPERAND
	JR	NC,ERRCALC
CALC3
	LD	A,(HL)
	OR	A
	JR	Z,CALC2
	CP	" "
	JR	NZ,ERRCALC
	INC	HL
	JR	CALC3
ERRCALC
	LD	A,2
	OUT	(#FE),A
	JR	LPCALC
CALC2
	LD	IX,OPER1
	CALL	STRNUM0
	JR	C,ERRCALC
	LD	(OPERAND1),HL
	LD	A,(OPERATION)
	CP	"="
	JR	Z,WORKCALC
	LD	IX,OPER2
	CALL	STRNUM0
	JR	C,ERRCALC
WORKCALC
	LD	DE,0
OPERAND1 EQU	$-2
	LD	A,0
OPERATION EQU	$-1
	CP	"="
	JR	Z,CALC5
	CP	"+"
	JR	Z,ADDCALC
	CP	"-"
	JR	Z,SBCCALC
	CP	"*"
	JR	Z,MULCALC
	CP	"/"
	JR	NZ,ERRCALC
	LD	A,H
	OR	L
	JR	Z,ERRCALC
	CALL	DIV
CALC5
	PUSH	DE
	JR	CALC4
MULCALC
	LD	C,L
	LD	B,H
	CALL	MUL
	JR	CALC5
ADDCALC
	ADD	HL,DE
	JR	CALC6
SBCCALC
	OR	A
	EX	DE,HL
	SBC	HL,DE
CALC6
	PUSH	HL
CALC4
	LD	A,13
	CALL	PRC
	LD	A,(OPERATION)
	CP	"="
	JR	NZ,CALC8
	LD	A,(DECHEX)
	CP	10
	LD	A,"#"
	JR	Z,CALC7
	LD	A," "
CALC7
	LD	(HEXDECF),A
CALC8
	POP	HL
	CALL	W_STR
	CALL	PRNUML0
	CALL	CLRBCALC
	LD	HL,BUFSTR
	LD	DE,BCALC
	LD	BC,5
	LDIR 
	JP	LPCALC
;
OPERAND
	LD	B,0
LPOPER
	LD	A,(HL)
	CP	"#"
	JR	Z,COPYC
	CALL	CHRNUM
	JR	C,ENDOPER
COPYC
	INC	B
	LD	A,(HL)
	LD	(DE),A
	INC	HL
	INC	DE
	JR	LPOPER
ENDOPER
	LD	A,B
	CP	6
	RET 
;
CLRBCALC
	LD	HL,BCALC
	LD	DE,BCALC+1
	LD	BC,10
	LD	(HL)," "
	LDIR 
	XOR	A
	LD	(DE),A
	RET 
;
HELP
	OR	A
	LD	HL,MSG_ABSENT
	LD	BC,(DIPOVERLAY)
	SBC	HL,BC
	JP	Z,SCAN
	JP	HELPOVR
;
CONCAT
	LD	A,(MREDF)
	OR	A
	JP	Z,SCAN
	CP	1
	JP	Z,SCAN
	PUSH	AF
	CALL	PRL
	DEFB	22,23,3,#FF,71,"CONCAT",0
	POP	BC
	LD	HL,BMR
	LD	A,(HL)
	CALL	REF
	LD	(FFM),A
	LD	C,A
	DEC	C
M1
	PUSH	HL
	PUSH	BC
	LD	BC,CAT
	CALL	ADF
	JR	Z,ERRZ
	INC	A
	CP	(HL)
	JR	Z,ERRZ
	POP	BC
	POP	HL
	LD	A,(HL)
	INC	HL
	CALL	REF
	INC	C
	CP	C
	JR	Z,NOERRZ
ERRZ
	RST	8
	DEFB	#75
NOERRZ
	DJNZ	M1
	CALL	YESNO_
	CALL	COPYCAT
	LD	A,0
FFM	EQU	$-1
	CALL	ADFC000
	LD	(ADZ),HL
	LD	DE,(MREDS)
	LD	HL,#FF
	CALL	DIV
	PUSH	BC
	LD	DE,#FF
	CALL	MUL
	OR	A
	LD	HL,(MREDS)
	SBC	HL,DE
	LD	A,L
	LD	(LASTLENZ),A
	POP	BC
	JR	Z,M2
	INC	C
M2
	LD	A,C
	LD	(LENZ),A
	LD	A,(MREDF)
	SUB	C
	LD	(SKIPFILES),A
	LD	C,A
	LD	HL,#C800+228
	LD	A,(HL)
	SUB	C
	LD	(HL),A
	LD	A,0
LENZ	EQU	$-1
	DEC	A
	JR	Z,ONEFILE
	EX	AF,AF'
	LD	A,"1"
	EX	AF,AF'
	LD	DE,0
ADZ	EQU	$-2
	LD	L,E
	LD	H,D
	LD	BC,16
	ADD	HL,BC
	EX	DE,HL
LPLDIRNAME
	PUSH	HL
	POP	IX
	LD	(IX+13),#FF
	LD	BC,16
	LDIR 
	EX	AF,AF'
	LD	(IX+16+8),A
	INC	A
	EX	AF,AF'
	PUSH	AF
	PUSH	HL
	XOR	A
	LD	(IX+16+	9),A
	LD	(IX+16+10),A
	LD	(IX+16+11),A
	LD	(IX+16+12),A
	LD	BC,14
	ADD	HL,BC
	LD	A,#FF
	CALL	NEWTS
	POP	HL
	POP	AF
	DEC	A
	JR	NZ,LPLDIRNAME
	LD	(IX+16+13),0
LASTLENZ EQU	$-1
	LD	BC,32
	JR	MOVECAT
ONEFILE
	LD	IX,(ADZ)
	LD	A,(LASTLENZ)
	LD	(IX+13),A
	LD	BC,16
MOVECAT
	ADD	IX,BC
	LD	(KUDALDIR),IX
	LD	BC,(ADZ)
	LD	A,(MREDF)
	CALL	ADF
	LD	(OTKUDALDIR),HL
	LD	DE,#C800
	EX	DE,HL
	OR	A
	SBC	HL,DE
	PUSH	HL
	POP	BC
	LD	HL,0
OTKUDALDIR EQU	$-2
	LD	DE,0
KUDALDIR EQU	$-2
	LDIR 
	LD	HL,0
SKIPFILES EQU	$-2
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	PUSH	HL
	POP	BC
	LD	A,B
	OR	C
	DEC	BC
	JR	Z,NOLDDR
	LD	HL,#C7FF
	LD	(HL),0
	LD	DE,#C7FE
	LDDR 
NOLDDR
	CALL	VSRCC
	JP	OKRENFIL
;
VSRCC
	CALL	VERIFICAT
	CALL	SAVECAT
	CALL	RESTORECAT
	CALL	CLRTMRBMR
	JP	CRCMS
;
SCRLOOK
	CALL	PRL
	DEFB	22,23,3,#FF,71,"Looking	screen",0
	CALL	VERIFICAT
	CALL	ADCF
	PUSH	HL
	POP	IX
	LD	C,(IX+11)
	LD	B,(IX+12)
	LD	A,(IX+8)
	CP	"C"
	JR	NZ,LOOKSIZE
	LD	HL,6912
	SBC	HL,BC
	LD	A,27
	JR	Z,LOOKS
LOOKSIZE
	LD	A,(IX+13)
	CP	24
	JR	C,LOOKS
	LD	A,24
LOOKS
	LD	(SCRLEN),A
	CALL	COPYSCR
	LD	HL,#E000
	PUSH	HL
	LD	A,#38
	CALL	CLRSCR2
	LD	BC,5
SCRLEN	EQU	$-1
	LD	E,(IX+14)
	LD	D,(IX+15)
	POP	HL
	PUSH	HL
	CALL	DOS
	POP	HL
	CALL	RSCR
	CALL	BORDER
	CALL	PRESSKEY
	XOR	A
	OUT	(#FE),A
	CALL	RESTORESCR
	RST	8
	DEFB	#FF
;
BORDER
	LD	HL,#FF00
	LD	DE,#FF01
	PUSH	HL
	PUSH	DE
	PUSH	HL
	PUSH	HL
	LD	BC,7
	LD	(HL),L
	LDIR 
	LD	B,255
	LD	HL,#5800
	POP	IX
LPBORD
	LD	A,(HL)
	RRA 
	RRA 
	RRA 
	AND	7
	LD	(DXCOLOR),A
	INC	(IX+0)
DXCOLOR	EQU	$-1
	INC	HL
	DJNZ	LPBORD
	POP	DE
	POP	HL
	LD	B,7
LPBORD2
	LD	A,(DE)
	CP	(HL)
	JR	NC,ENDLPB
	LD	E,L
	LD	D,H
ENDLPB
	INC	HL
	DJNZ	LPBORD2
	POP	HL
	OR	A
	EX	DE,HL
	SBC	HL,DE
	LD	A,L
	OUT	(#FE),A
	RET 
;
PRESSKEY
	XOR	A
	LD	(23560),A
WAIT
	LD	A,(23560)
	OR	A
	JR	Z,WAIT
	RET 
;
COPYSCR
	LD	HL,16384
	LD	DE,#C000
LDBCLDIR
	LD	BC,6912
	LDIR 
	RET 
;
RESTORESCR
	LD	HL,#C000
RSCR
	LD	DE,16384
	JR	LDBCLDIR
;
RUN
	CALL	ADCF
	JP	Z,SCAN
	INC	A
	CP	(HL)
	JP	Z,SCAN
	PUSH	HL
	POP	IX
	LD	A,(IX+8)
	CP	"C"
	JR	Z,CODE
	CP	"B"
	JP	NZ,SCAN
	PUSH	HL
	LD	DE,NAMERUN
	CALL	COPYNAME
	CALL	PRL
	DEFB	22,23,3,#FF,71,"RUN ",#22,"	   ",#22,0
NAMERUN	EQU	$-10
	POP	HL
	LD	DE,#5D92
	LD	BC,8
	LDIR 
	XOR	A
	JR	RETBASIC
CODE
	LD	A,(IX+13)
	CP	192
	JR	NZ,LOADCODE
	LD	DE,NAMEMAGIC
	CALL	COPYNAME
	CALL	PRL
	DEFB	22,23,3,#FF,71,"GOTO ",#22,"	    ",#22
	DEFB	"CODE",0
NAMEMAGIC EQU	$-14
	PUSH	IX
	POP	HL
	PUSH	HL
	LD	BC,8
	ADD	HL,BC
	LD	A," "
SKIPSP
	DEC	HL
	CP	(HL)
	JR	NZ,NOSP
	DEC	C
	JR	SKIPSP
NOSP
	POP	HL
	LD	DE,#5DAF
	LDIR 
	EX	DE,HL
	LD	(HL),#22	;char "
	INC	HL
	LD	(HL),#AF	;token CODE
	LD	A,1
RETBASIC
	LD	(#C000),A
	CALL	VERIFICAT
RESTORERET
	POP	HL
RESTORE
	EXX 
	LD	HL,0
ERRSP	EQU	$-2
	LD	(#5C3D),HL
	LD	HL,0
SAVEHL	EQU	$-2
	EXX 
	RET 
LOADCODE
	LD	DE,NAMECODE
	CALL	COPYNAME
	CALL	PRL
	DEFB	22,23,3,#FF,71,"LOAD ",#22,"	    ",#22
	DEFB	"CODE ",0
NAMECODE EQU	$-15
NEWINPUT
	LD	L,(IX+9)
	LD	H,(IX+10)
	LD	DE,#1717
	CALL	INP_W
	LD	(LOADAD),HL
	JR	C,NEWINPUT
	CALL	PRL
	DEFB	13,"RANDOMIZE USR ",0
NEWINPUT2
	LD	HL,(LOADAD)
	LD	DE,#E17
	CALL	INP_W
	LD	(STARTAD),HL
	JR	C,NEWINPUT2
	CALL	VERIFICAT
	CALL	RESTORE
	POP	DE
	LD	HL,0
STARTAD	EQU	$-2
	PUSH	HL
	LD	HL,0
LOADAD	EQU	$-2
	LD	B,(IX+13)
	LD	E,(IX+14)
	LD	D,(IX+15)
	LD	C,5
	JP	#3D13
COPYNAME
	PUSH	IX
	POP	HL
	LD	BC,8
	LDIR 
	RET 
;
QUIT
	CALL	PRL
	DEFB	22,23,3,#FF,71,"QUIT to	TR-DOS",0
	CALL	YESNO_
	JP	RESTORERET
	LD	IX,0
CALLDOS
	PUSH	IX
	JP	#3D2D
;
HEXDECMAIN
	CALL	HEXDEC
	JP	SCAN
;
HEXDEC
	LD	HL,HEXDECF
	LD	A,"#"
	CP	(HL)
	JR	NZ,SETHEXDEC
	LD	A," "
SETHEXDEC
	LD	(HL),A
	CALL	ODI
	CALL	OMI
	LD	A,(NUMF)
	OR	A
	RET	Z
	LD	A,(FILESOUT1)
	CP	60
	JP	Z,OFI
	JP	GOPRS
;
CHGMDMAIN
	CALL	CHANGEMODE
	JP	SCAN
;
CHANGEMODE
	LD	HL,FILESOUT1
	LD	A,60
	CP	(HL)
	LD	E,4
	LD	BC,15
	LD	HL,WIND0
	JR	NZ,SETMODEOUT
	CALL	CORRCLFOF
	LD	A,14
	LD	BC,#C90E
	LD	E,5
	LD	HL,WIND1
SETMODEOUT
	LD	(ADWIND1),HL
	LD	HL,OFI
	LD	(HL),B
	LD	(FILESOUT1),A
	LD	A,E
	LD	(LINESCMDL),A
	LD	A,C
	LD	(FILES1),A
OUTLEFTS
	CALL	CLS0
	CALL	OUTSL
	JP	GOPRS
;
CORRCLFOF
	LD	A,(CL)
LPCORR
	SUB	15
	JR	NC,LPCORR
	ADD	A,15
	LD	(CL),A
	LD	C,A
	LD	A,(CF)
	SUB	C
	LD	(FOF),A
	LD	A,(CL)
	CP	14
	RET	NZ
	DEC	A
	LD	(CL),A
	LD	HL,FOF
	INC	(HL)
	RET 
;
CHDRV
	LD	A,(#5D19)
	ADD	A,"A"
	LD	(DRV_),A
	CALL	PRL
	DEFB	22,23,3,#FF,71,"Select DRIVE: ",22,23,16,0
DRV_	EQU	$-5
	LD	HL,DRV_
	CALL	SELDRIVE
	LD	A,(DRV_)
	SUB	"A"
DRIVE1
	CALL	NEWDRV
	JP	RCAT
;
SELDRIVE
	XOR	A
	LD	(BREAK),A
	LD	(DRIVEAD),HL
SELDRV
	CALL	INCHR
	CP	13
	RET	Z
	CP	CS1
	RET	Z
	CP	"e"
	JR	NC,SELDRV
	SUB	"a"
	JR	C,SELDRV
	ADD	A,"A"
	LD	(0),A
DRIVEAD	EQU	$-2
	JP	PRC
;
NEWDRV
	PUSH	AF
	LD	C,1
	CALL	DOS
	POP	AF
	LD	(23800),A
	LD	(23801),A
	LD	(#5D19),A
	RET 
;
MRFIL
	CALL	MARKF
	JP	DOWNMAIN
;
MARKF
	LD	A,(CF)
MARKFC
	LD	IX,TMR
	LD	(MRFILE),A
	LD	(CUF1),A
	LD	(CUF2),A
	CALL	CLEARF_
	RET	Z
	LD	BC,13
	ADD	HL,BC
	LD	A,(IX+0)
CUF1	EQU	$-1
	CPL 
	LD	(IX+0),A
CUF2	EQU	$-1
	OR	A
	LD	A,MATTR
	JR	NZ,SELATT
	LD	A,FATTR
SELATT
	LD	(MRATT),A
	LD	C,(HL)
	LD	B,0
	LD	HL,(MREDS)
	LD	A,(MREDF)
	JR	Z,SUBF
	CALL	ADDFILE
	JR	ENDMRFIL
SUBF
	CALL	SUBFILE
ENDMRFIL
	CALL	SETATT
	CALL	OMI
	SCF 
	RET 
;
SETATT
	LD	A,(CL)
SETATT2
	ADD	A,A
	LD	E,A
	LD	D,0
	LD	IX,(ADWIND1)
	ADD	IX,DE
	LD	A,(IX+1)
	LD	(YATT),A
	CALL	PRL
	DEFB	22,0,0,0
YATT	EQU	$-3
	LD	HL,(DYATTR)
	LD	A,(IX)
	SRL	A
	ADD	A,L
	LD	L,A
	LD	E,L
	LD	D,H
	INC	E
	LD	BC,20
	LD	A,(FILESOUT1)
	CP	60
	JR	NZ,WDEC
	LD	BC,5
	LD	A,(IX)
	SRL	A
	JR	C,WDEC
	DEC	C
WDEC
	LD	(HL),0
MRATT	EQU	$-1
	LDIR 
	RET 
;
ADDFILE
	ADD	HL,BC
	INC	A
	LD	(MREDF),A
	LD	(MREDS),HL
	LD	HL,BMR
	LD	BC,128
	LD	A,#FF
	CPIR 
	DEC	HL
	LD	A,(MRFILE)
	LD	(HL),A
;
SORT
	DEFB	0
	LD	BC,#8000
	LD	DE,TMR
	LD	HL,BMR
REPEAT
	LD	A,(DE)
	OR	A
	JR	Z,SKIPMR
	LD	(HL),C
	INC	HL
SKIPMR
	INC	DE
	INC	C
	DJNZ	REPEAT
	RET 
;
SUBFILE
	DEC	A
	SBC	HL,BC
	LD	(MREDF),A
	LD	(MREDS),HL
	LD	HL,BMR
	LD	BC,128
	LD	A,(MRFILE)
	CPIR 
	LD	A,128
	SUB	0
MRFILE	EQU	$-1
	LD	C,A
	LD	B,0
	LD	E,L
	LD	D,H
	DEC	DE
	LDIR 
	RET 
;
RENFIL
	CALL	COPYCAT
	LD	A,(CF)
	CALL	REF
	CALL	ADFC000
	JP	Z,SCAN
	LD	A,(HL)
	LD	(FRSTBYTE),A
	LD	(RENADR),HL
	CALL	PTR
	CALL	PRL
	DEFB	22,23,3,#FF,71,"Rename FILE",0
	CALL	COORDLINE
	LD	A,(ATX)
	LD	D,A
	LD	HL,(DYATTR)
	SRL	A
	ADD	A,L
	LD	L,A
	LD	A,(HL)
	LD	(ATTR),A
	LD	A,(ATY)
	LD	E,A
	PUSH	DE
	LD	A,8
	LD	HL,0
RENADR	EQU	$-2
	CALL	INP
	POP	DE
	LD	A,D
	ADD	A,9
	LD	D,A
	LD	HL,(RENADR)
	LD	BC,8
	ADD	HL,BC
	LD	A,1
	CALL	INP
	CALL	VERIFICAT
	LD	A,0
FRSTBYTE EQU	$-1
	CP	1
	JR	NZ,SVCAT
	LD	HL,(RENADR)
	LD	A,1
	CP	(HL)
	JR	Z,SVCAT
	LD	HL,#C800+244 ;DOD
	DEC	(HL)
	CALL	PRL
	DEFB	13,#FF,INK,"File is UnErased",0
SVCAT
	CALL	SAVECAT
	CALL	RESTORECAT
	CALL	CRCMS
OKRENFIL
	CALL	CLSRST870_
	CALL	SETCFCLFOF
	RST	8
	DEFB	#FF
;
CLSRST870_
	LD	A,(NUMF)
	OR	A
	RET	NZ
	CALL	CLS0
	RST	8
	DEFB	#70
;
REF
	LD	IX,TFILS
	LD	(DXTF),A
	LD	A,(IX)
DXTF	EQU	$-1
	RET 
;
RENTIT
	CALL	PRL
	DEFB	22,23,3,#FF,71,"Rename TITLE",0
	CALL	COPYCAT
	LD	HL,#C800+245
	LD	DE,#3602
	LD	A,71
	LD	(ATTR),A
	LD	A,8
	CALL	INP
	CALL	VERIFICAT
	JR	SVCAT
;
DELETE
	LD	A,(MREDF)
	OR	A
	JR	NZ,DELETE2
	CALL	ADCF
	JP	Z,SCAN
	INC	A
	CP	(HL)
	JP	Z,SCAN
	CALL	MARKF
DELETE2
	LD	A,(MREDF)
	LD	(NFILESIS),A
	CALL	PRL
	DEFB	22,23,3,#FF,71,"DELETE",0
	CALL	YESNO_
	CALL	COPYCAT
	DI 
	LD	IY,BMR
NEXTF
	LD	A,(IY)
	CP	#FF
	JP	Z,ENDDEL
	CALL	REF
	CALL	ADFC000
	JR	Z,DECFILESIS
	INC	A
	CP	(HL)
	JR	NZ,DFIL
DECFILESIS
	LD	HL,NFILESIS
	DEC	(HL)
	JR	LPDEL
DFIL
	LD	A,1
	LD	(HL),A
	LD	HL,#C800+244
	INC	(HL)
LPDEL
	INC	IY
	JR	NEXTF
ENDDEL
	LD	BC,#C000
	CALL	CORRECTDEL
	LD	IY,#5C3A
	EI 
	CALL	VSRCC
	CALL	CLSRST870_
	CALL	SETCFCLFOF
	CALL	FILESIS
	CALL	PRL
	DEFB	"deleted",0
	RST	8
	DEFB	#FF
;
FILESIS
	CALL	PRL
	DEFB	13,#FF,INK,0
	LD	HL,#A0ED
	LD	(LDNOP),HL
	LD	L,0
NFILESIS EQU	$-1
	CALL	PRNLEFTSP
	LD	HL,#1200
	LD	(LDNOP),HL
	CALL	PRL
	DEFB	" file(s) is ",0
	RET 
;
CORRECTDEL
	DI 
	LD	IY,#900
	ADD	IY,BC
	LD	A,(IY-28)
	PUSH	AF
	CALL	ADF
	POP	BC
	LD	DE,16
	LD	A,1
CORRECT
	OR	A
	SBC	HL,DE
	CP	(HL)
	RET	NZ
	DEC	(HL)
	PUSH	HL
	POP	IX
	EXX 
	LD	C,(IX+13)
	LD	B,0
	LD	L,(IY-27)
	LD	H,(IY-26)
	ADD	HL,BC
	LD	(IY-27),L
	LD	(IY-26),H
	LD	C,(IX+14)
	LD	B,(IX+15)
	LD	(IY-31),C
	LD	(IY-30),B
	DEC	(IY-12)
	DEC	(IY-28)
	EXX 
	DJNZ	CORRECT
	RET 
;
SETCFCLFOF
	LD	A,(NUMF)
	DEC	A
	LD	HL,CF
	CP	(HL)
	RET	NC
	LD	(HL),A
	LD	HL,FOF
	CP	(HL)
	JR	NC,NONEWFOF
	LD	HL,CL
	CP	(HL)
	JR	NC,SETFOF
	LD	(CL),A
	XOR	A
	JR	SETFOF2
SETFOF
	SUB	(HL)
SETFOF2
	LD	(FOF),A
	RET 
NONEWFOF
	SUB	(HL)
	LD	(CL),A
	RET 
;
MASK
	CALL	PRTMASK
	LD	HL,NAME
	LD	DE,#C000
	PUSH	DE
	LD	BC,9
	LDIR 
	XOR	A
	LD	(C_ALL),A
	LD	A,8
	POP	HL
	PUSH	HL
	LD	DE,#3201
	CALL	INP
	LD	A,1
	LD	HL,#C008
	LD	DE,#3B01
	CALL	INP
	LD	A,#AF
	LD	(C_ALL),A
	POP	HL
	LD	DE,NAME
	LD	BC,9
	LDIR 
SETMASK
	CALL	CMSTMRBMR
	JP	OKRENFIL
;
MODEMASK
	CALL	PRTMASK
	CALL	PRL
	DEFB	22,17,61,#FF,71,0
	LD	HL,MSFLAG
	CALL	NEWMODE
	JR	SETMASK
;
MASK_B
	CALL	CLRMASK
	LD	(HL),"B"
	JR	SETMASK
;
CLEARMASK
	CALL	CLRMASK
	JR	SETMASK
;
CLRMASK
	LD	HL,NAME
	LD	DE,NAME+1
	LD	BC,8
	LD	(HL),""
	LDIR 
PRTMASK
	PUSH	HL
	LD	HL,NEWMSK
	CALL	PRT
	POP	HL
	RET 
;
MODEALL
	LD	HL,RETYN
	XOR	A	;NOP
	CP	(HL)
	LD	C,"-"
	JR	NZ,SETMD
	LD	A,#C8	;RET Z
	LD	C,"+"
SETMD
	LD	(HL),A
	LD	A,C
	LD	(PLUSDEL),A
DELONOFF
	CALL	PRL
	DEFB	#FF,71,22,6,63,0
	LD	A,(PLUSDEL)
	CP	"+"
	LD	A,"-"
	JR	Z,SETMDDEL
	LD	A,"+"
SETMDDEL
	LD	(PLUSDEL),A
	CALL	CMSTMRBMR
	LD	A,(NUMF)
	OR	A
	CALL	Z,CLS0
	CALL	SETCFCLFOF
	RST	8
	DEFB	#76
;
CMSTMRBMR
	LD	HL,#C000
	PUSH	HL
	LD	DE,#C001
	LD	BC,128
	LD	(HL),#FF
	LDIR 
	LD	HL,BMR
	POP	DE
LPCRBMR
	LD	A,(HL)
	CP	#FF
	JR	Z,ENDLPCRBMR
	CALL	REF
	LD	(DE),A
	INC	HL
	INC	DE
	JR	LPCRBMR
ENDLPCRBMR
	CALL	CLRTMRBMR
	CALL	CRCMS
	LD	A,(NUMF)
	OR	A
	RET	Z
	LD	(NUMF2),A
	DI 
	LD	IY,TMR
	XOR	A
	LD	(CFILE),A
	LD	DE,BMR
LPNEWBMR
	LD	A,0
CFILE	EQU	$-1
	CALL	REF
	LD	HL,#C000
	LD	BC,128
	CPIR 
	JR	NZ,NOCOPYFILE
	LD	A,(CFILE)
	LD	(DE),A
	INC	DE
	LD	(FILEONTMR),A
	LD	HL,MREDF
	INC	(HL)
	CALL	ADFCMS
	LD	BC,13
	ADD	HL,BC
	LD	C,(HL)
	LD	B,0
	LD	HL,(MREDS)
	ADD	HL,BC
	LD	(MREDS),HL
	LD	(IY),#FF
FILEONTMR EQU	$-2
NOCOPYFILE
	LD	A,(CFILE)
	INC	A
	LD	(CFILE),A
	CP	0
NUMF2	EQU	$-1
	JR	NZ,LPNEWBMR
	LD	IY,#5C3A
	EI 
	RET 
;
MODEMARK
	CALL	PRL
	DEFB	22,17,53,#FF,71,0
	LD	HL,SORT
	CALL	NEWMODE
	LD	A,(SORT)
	OR	A
	CALL	Z,SORT
	JP	SCAN
;
NEWMODE
	XOR	A
	CP	(HL)
	LD	B,#C9
	LD	A,"E"
	JR	Z,SETMODEMR
	LD	B,0
	LD	A,"N"
SETMODEMR
	LD	(HL),B
	JP	PRC
;
LOOKING
	LD	A,(BMR)
	INC	A
	JP	Z,SCAN
	CALL	PRL
	DEFB	22,10,49,#FF,#42,"Looking Mode",0
	LD	A,(FOF)
	LD	(OLDFOF),A
	LD	A,(CF)
	LD	(OLDCF),A
	LD	A,(CL)
	LD	(OLDCL),A
	LD	A,MATTR
	LD	(FILEATTR),A
	XOR	A
	LD	(FOF),A
	LD	(CF),A
	LD	(CL),A
	CALL	CRCMR
	CALL	GOPRS
	LD	A,#C9
	LD	(BREAK),A
SCANLOOK
	CALL	PRL
	DEFB	22,23,3,0
	CALL	INCHR
	CP	CS7
	JR	Z,UPLOOK
	CP	"9"
	JR	Z,UPLOOK
	CP	CS6
	JR	Z,DOWNLOOK
	CP	"o"
	JR	Z,DOWNLOOK
	CP	"8"
	JR	Z,DOWNLOOK
	CP	CS5
	JR	Z,LEFTLOOK
	CP	"i"
	JR	Z,LEFTLOOK
	CP	"6"
	JR	Z,LEFTLOOK
	CP	CS8
	JR	Z,RIGHTLOOK
	CP	"p"
	JR	Z,RIGHTLOOK
	CP	"7"
	JR	Z,RIGHTLOOK
	CP	"#"
	JR	Z,HEXDECLOOK
	CP	EXTEND
	JR	Z,CHGMDLOOK
	CP	"_"
	JR	NZ,SCANLOOK
	CALL	CRCMS
	LD	A,FATTR
	LD	(FILEATTR),A
	LD	A,0
OLDFOF	EQU	$-1
	LD	(FOF),A
	LD	A,0
OLDCF	EQU	$-1
	LD	(CF),A
	LD	A,0
OLDCL	EQU	$-1
	LD	(CL),A
	LD	A,(FILESOUT1)
	CP	14
	CALL	Z,CORRCLFOF
	CALL	PRL
	DEFB	22,10,49,#FF,0,0
	LD	HL,SP12
	CALL	PRT
	CALL	GOPRS
	JP	SCAN
;
UPLOOK
	CALL	UP
	JP	SCANLOOK
;
DOWNLOOK
	CALL	DOWN
	JP	SCANLOOK
;
LEFTLOOK
	CALL	LEFT
	JP	SCANLOOK
;
RIGHTLOOK
	CALL	RIGHT
	JP	SCANLOOK
;
HEXDECLOOK
	CALL	HEXDEC
	JP	SCANLOOK
;
CHGMDLOOK
	CALL	CHANGEMODE
	JP	SCANLOOK
;
CRCMR
	LD	IX,BMR
	XOR	A
	LD	DE,#C000
	PUSH	DE
LPCRCMR
	LD	(NUMF),A
	EX	AF,AF'
	LD	A,(IX)
	CP	#FF
	JR	Z,ENDCRCMR
	CALL	ADFCMS
	LD	BC,16
	LDIR 
	INC	IX
	EX	AF,AF'
	INC	A
	JR	LPCRCMR
ENDCRCMR
	POP	HL
	LD	DE,CMS
	LD	BC,#800
	LDIR 
	RET 
;
SELECT
	CALL	PRL
	DEFB	22,23,3,#FF,71,0
	LD	HL,#FFFE
	LD	DE,#FF3E
	JR	MARKMASK
;
UNSELECT
	CALL	PRL
	DEFB	22,23,3,#FF,71,"Un",0
	LD	HL,#FE
	LD	DE,#3E
;
MARKMASK
	LD	(METOD1),HL
	LD	(METOD2),DE
	CALL	PRL
	DEFB	"Select	<",0
	LD	A,(ATX)
	LD	(ATXMS),A
	LD	HL,MASKMR
	LD	A,(TYPEMR)
	PUSH	AF
	XOR	A
	LD	(TYPEMR),A
	LD	(C_ALL),A
	LD	(SELYES),A
	CALL	PRT
	CALL	PRCSP
	LD	A,(ATX)
	LD	(ATXTYP),A
	POP	AF
	LD	(TYPEMR),A
	CALL	PRC
	LD	A,">"
	CALL	PRC
	LD	A,8
	LD	DE,#17
ATXMS	EQU	$-1
	LD	HL,MASKMR
	CALL	INP
	LD	A,1
	LD	DE,#17
ATXTYP	EQU	$-1
	LD	HL,TYPEMR
	CALL	INP
	LD	A,#AF
	LD	(C_ALL),A
	LD	IX,TMR
	XOR	A
	LD	(FM),A
LPFM
	CALL	CLEARF_
	JR	Z,ENDLPFM
	LD	(FILEAD),HL
	LD	B,9
	LD	DE,MASKMR
LPVERIMASK
	LD	A,(DE)
	CP	""
	JR	Z,CONTLP
	CP	(HL)
	JR	NZ,ENDLPFM
CONTLP
	INC	HL
	INC	DE
	DJNZ	LPVERIMASK
	LD	A,#FF
	LD	(SELYES),A
	LD	BC,13
	LD	HL,0
FILEAD	EQU	$-2
	ADC	HL,BC
	LD	A,(HL)
	LD	(SIZEF),A
	LD	A,(FM)
	LD	(MRFILE),A
	LD	(FMDX1),A
	LD	(FMDX2),A
	LD	A,(IX)
FMDX1	EQU	$-1
METOD1	CP	0
	JR	Z,ENDLPFM
METOD2	CPL 
	NOP 
	LD	(IX),A
FMDX2	EQU	$-1
	OR	A
	LD	BC,0
SIZEF	EQU	$-2
	LD	A,(MREDF)
	LD	HL,(MREDS)
	JR	Z,FSUB
	CALL	ADDFILE
	JR	ENDLPFM
FSUB
	CALL	SUBFILE
ENDLPFM
	LD	C,0
FM	EQU	$-1
	INC	C
	LD	A,(NUMF)
	CP	C
	LD	A,C
	LD	(FM),A
	JR	NZ,LPFM
	LD	A,0
SELYES	EQU	$-1
	OR	A
	JR	Z,NOSELECT
	RST	8
	DEFB	#FF
NOSELECT
	RST	8
	DEFB	#71
;
CLEARF_
	LD	C,A
	CALL	ADFCMS
	PUSH	HL
	XOR	A
	LD	B,16
CLEARF_2
	OR	(HL)
	INC	HL
	DJNZ	CLEARF_2
	POP	HL
	LD	A,C
	RET 
;
YESNO_
	CALL	YESNO_2
	RET	C
	RST	8
	DEFB	#73
;
YESNO_2
	CALL	PRL
	DEFB	" Yes/No? ",0
	XOR	A
	LD	(BREAK),A
SCANYN
	CALL	INCHR
	CP	"n"
	JR	Z,PRTNO
	CP	"y"
	JR	NZ,SCANYN
	CALL	PRL
	DEFB	"Yes",0
	SCF 
	RET 
PRTNO
	CALL	PRL
	DEFB	"No",0
	OR	A
	RET 
;
VERIFICAT
	LD	HL,#C900
	PUSH	HL
	LD	DE,0
	LD	BC,#905
	CALL	DOS
	LD	HL,CAT
	POP	DE
	LD	BC,#900
	CALL	VERILP
	RET	Z
	RST	8
	DEFB	#72
;
VERILP
	LD	A,(DE)
	CP	(HL)
	RET	NZ
	LDI 
	LD	A,B
	OR	C
	JR	NZ,VERILP
	RET 
;
SAVECAT
	LD	HL,#C000
	LD	DE,0
	LD	BC,#906
	JP	DOS
;
RESTORECAT
	LD	HL,#C000
	LD	DE,CAT
BC900LDIR
	LD	BC,#900
	LDIR 
	RET 
;
COPYCAT
	LD	HL,CAT
	LD	DE,#C000
	JR	BC900LDIR