	ORG	#6000
FONT
	INCBIN	"fnt"
	ORG	#6800
	JP	OVERLAY
;
UP_MAIN
	CALL	SETPAGE0
	CALL	MAIN_
	LD	A,#C9		    
	LD	(#5CC2),A		
	LD	A,(#5D0F)		
	CP	6		
	LD	HL,ND_MES		
	JR	Z,NORM_ERR
	LD	A,(IY)		     
	CP	20
	JR	NZ,NOBREACK
	LD	(ERS2),A
NOBREACK
	LD	(ERRIY),A
	LD	HL,ERR_MESS
	LD	B,LEN_EM	       
FINDERR
	CP	(HL)		   
	INC	HL		 
	JR	NZ,NOFINDERR
	LD	E,(HL)		     
	INC	HL		 
	LD	D,(HL)
	EX	DE,HL		    
	JR	NORM_ERR	       
NOFINDERR
	INC	HL
	INC	HL		 
	DJNZ	FINDERR		      
NORM_ERR
	LD	A,(ERS2)	       
	OR	A
	JR	Z,NOTHING
	PUSH	HL		 
	LD	A,#FF		    
	LD	(ERS1),A	       
	LD	(MOVEFLAG),A
	LD	A,(NUMF)
	OR	A		
	JR	Z,NOREOUT		
	CALL	OUTSL		    
	CALL	GOPRS		    
NOREOUT
	CALL	OUTSR		    
	CALL	ODI		  
	CALL	CORRECTMI		
	CALL	OMI		  
	CALL	OSI		  
	POP	HL		 
NOTHING
	CALL	PRT		  
	LD	A,#72
	CP	(IY)		   
	JR	NZ,NOERR72
	CALL	BEEPINIT	       
	CALL	BEEPINSERT
NOERR72
	CALL	PRCSP		    
	LD	A,(#5D19)		
	LD	HL,23798	       
	CP	(HL)		   
	JP	Z,UP_MAIN
	CALL	NEWDRV		     
	JP	UP_MAIN
;					
CORRECTMI
	LD	HL,0		   
	LD	(SAVEMEMSEC),HL
	LD	(MREDS),HL
	XOR	A		
	LD	(MREDF),A		
	LD	IX,TMR		     
LPCORRMI
	PUSH	AF		 
	LD	(DXTMRC),A
	EX	AF,AF'		     
	LD	A,(IX)		     
DXTMRC	EQU	$-1
	OR	A		
	JR	Z,NOINCMRED
	LD	HL,MREDF	       
	INC	(HL)		   
	EX	AF,AF'		     
	CALL	ADFCMS
	LD	BC,13		    
	ADD	HL,BC		    
	LD	C,(HL)		     
	LD	B,0		  
	LD	HL,(MREDS)
	ADD	HL,BC		    
	LD	(MREDS),HL
NOINCMRED
	POP	AF		 
	INC	A		
	CP	128		  
	JR	NZ,LPCORRMI
	RET		   
;					
MAIN_
	LD	(#5C3D),SP
	LD	(IY),#FF	       
	XOR	A
	LD	(#5D0F),A
	LD	A,0		  
ERS2	EQU	$-1
	OR	A		
	LD	A,(#5D19)		
	JP	Z,DRIVE1
	LD	A,0
ERRIY	EQU	$-1
	CP	#76
	JR	Z,NOPC
	CALL	PRL		  
	DEFB	13,#FF,71,"PC>",0
NOPC
	CALL	CHECKWP
	LD	(WPFLAG),A
SCAN
	LD	A,#C9		    
	LD	(BREAK),A		
NEXTSCAN
	CALL	INCHR2		     
	LD	HL,TKEY		      
FIND_
	BIT	7,(HL)		     
	JR	NZ,NEXTSCAN
	CP	(HL)		   
	INC	HL		 
	JR	Z,SEL		    
	INC	HL		 
	INC	HL		 
	JR	FIND_		    
SEL
	LD	(PRESSK),A
	LD	E,(HL)		     
	INC	HL		 
	LD	D,(HL)		     
	LD	A,0		  
NUMF	EQU	$-1
	OR	A		
	JR	NZ,PRESENT
	LD	HL,WORKNF		
	LD	BC,LENWNF		
	LD	A,0		  
PRESSK	EQU	$-1
	CPIR		    
	JR	NZ,NEXTSCAN
PRESENT
	EX	DE,HL		    
	JP	(HL)		   
;					
DOS
	PUSH	AF		 
	PUSH	HL		 
	LD	HL,#5CC8
	LD	A,(#5D19)
	ADD	A,L
	LD	L,A
	LD	(HL),#83
	XOR	A		
	LD	(#5D10),A		
	LD	(#5D0F),A		
	LD	A,#C3		    
	LD	(#5CC2),A		
	LD	HL,C9PRG	       
	LD	(#5CC3),HL
	POP	HL		 
	POP	AF		 
	CALL	#3D13		    
	LD	A,#C9		    
	LD	(#5CC2),A		
	RET		   
;					
C9PRG
	POP	HL
	PUSH	HL		 
	PUSH	AF		 
	PUSH	DE		 
	EX	DE,HL		    
	OR	A		
	LD	HL,#D6B		      
	SBC	HL,DE		    
	JR	Z,C9E		    
	OR	A		
	LD	HL,#10		     
	SBC	HL,DE		    
	JR	Z,C9CH		     
	OR	A		
	LD	HL,#333		      
	SBC	HL,DE		    
	JR	Z,C92		    
	OR	A		
	LD	HL,#1A1B	       
	SBC	HL,DE		    
	JR	Z,DECDOWN
	POP	DE		 
	POP	AF		 
	RET		   
C9CH
	PUSH	AF		 
	LD	A,MATTR
	LD	(ATTR),A	       
	POP	AF		 
	CALL	PRC		  
C9E
	POP	DE		 
	POP	AF		 
C9E1
	POP	HL		 
	RET		   
C92
	POP	DE		 
	POP	AF		 
	CALL	#333		   
	AND	#DF		  
	LD	HL,MS_R		      
	CP	"R"		  
	JR	Z,C94		    
	LD	HL,MS_I		      
	CP	"I"		  
	JR	Z,C94		    
	LD	HL,MS_A		      
	CP	"A"		  
	JR	NZ,C9E1		      
C94
	PUSH	AF		 
	PUSH	BC		 
	PUSH	DE		 
	CALL	PRT		  
	POP	DE		 
	POP	BC		 
	POP	AF		 
	JR	C9E1		   
;					
DECDOWN
	CALL	BC2DEC1		      
	JR	C9E
BC2DEC1
	LD	L,C		  
	LD	H,B		  
	JP	BC222		    
;
INCHR2
	CALL	PRL
	DEFB	22,23,3,0
	XOR	A
	LD	(23560),A
	LD	HL,1
NEXTIN2
	HALT 
	HALT 
	LD	(TIME),HL
	CALL	CHECKWP
	LD	HL,WPFLAG
	CP	(HL)
	JR	NZ,DISKCHG
	LD	A,(23560)
	OR	A
	JP	NZ,RESETCURS
	LD	HL,0
TIME	EQU	$-2
	DEC	HL
	LD	A,L
	OR	H
	JR	NZ,NEXTIN2
	CALL	CURS
	LD	HL,5
	JR	NEXTIN2
;
DISKCHG
	CALL	PRL
	DEFB	22,23,3,#FF,71,"Disk change!",0
	XOR	A
	LD	(ERS2),A
RCAT
	CALL	SETPAGE0
	CALL	CLS1
	CALL	PRL		  
	DEFB	13,#FF,INK,"Reading catalogue",0
	LD	HL,#C000
	LD	DE,0
	LD	BC,#905
	CALL	DOS
	CALL	PRL
	DEFB	13,#FF,INK,"Catalogue is readed",0
	CALL	INITBUFS
	CALL	RESTORECAT
	CALL	CRCMS
	LD	A,#FF
	LD	(ERS2),A
	LD	A,(NUMF)
	OR	A
	JR	Z,NOFILES
	RST	8
	DEFB	#FF
NOFILES
	RST	8
	DEFB	#70
;
SETPAGE0
	LD	A,#10
	EX	AF,AF'
	LD	A,(PAGES)
SETPAGE
	LD	BC,#7FFD
PORT2	EQU	$-2
	OUT	(C),A
	LD	B,#7F
	EX	AF,AF'
	OUT	(C),A
	RET 
;
INITBUFS
	XOR	A
	LD	(FOF),A
	LD	(CF),A
	LD	(CL),A
CLRTMRBMR
	XOR	A
	LD	(MREDF),A
	LD	(MREDS),A
	LD	(MREDS+1),A
	LD	HL,BMR
	LD	DE,BMR+1
	LD	(HL),#FF
	LD	BC,128
	LDIR 
CLRTMR
	LD	HL,TMR
	LD	DE,TMR+1
	LD	(HL),0
	LD	BC,127
	LDIR 
	RET 
;
CLRCMS
	LD	HL,CMS
	LD	DE,CMS+1
	LD	(HL),0
	LD	BC,#7FF
	LDIR 
	RET 
;
CRCMS
	LD	IX,TFILS
	CALL	CLRCMS
	XOR	A
	LD	(NUMF),A
	LD	(DELSEC),A
	LD	(DELSEC+1),A
	LD	HL,CAT
	LD	(CUCAT),HL
	LD	HL,CMS
	LD	(CUCMS),HL
	LD	(CNTR),A
NEXTNAME
	LD	HL,(CUCAT)
	XOR	A
	CP	(HL)
RETYN	RET	Z
	INC	A
	CP	(HL)
	JR	NZ,SKIP1
	EX	DE,HL
	LD	HL,13
	ADD	HL,DE
	LD	E,(HL)
	LD	D,0
	LD	HL,(DELSEC)
	ADD	HL,DE
	LD	(DELSEC),HL
	LD	A,(PLUSDEL)
	CP	"+"
	JR	NZ,END000
SKIP1
	LD	DE,(CUCAT)
	LD	HL,NAME
	LD	B,9
NEXT
	LD	A,""
	CP	(HL)
	JR	Z,SKIP2
	LD	A,(DE)
	CALL	CP_CHRMS
	JR	NZ,END000
SKIP2
	INC	HL
	INC	DE
	DJNZ	NEXT
	LD	HL,NUMF
	INC	(HL)
	LD	HL,(CUCAT)
	LD	DE,0
CUCMS	EQU	$-2
	LD	BC,16
	LDIR 
	LD	(CUCAT),HL
	LD	(CUCMS),DE
	LD	A,0
CNTR	EQU	$-1
	LD	(IX),A
	INC	IX
	JR	LPCRCMS
END000
	LD	HL,0
CUCAT	EQU	$-2
	LD	BC,16
	ADD	HL,BC
	LD	(CUCAT),HL
LPCRCMS
	LD	A,(CNTR)
	INC	A
	LD	(CNTR),A
	CP	128
	JR	NZ,NEXTNAME
	RET 
;
CP_CHRMS
	CP	(HL)
	RET	Z
	LD	(CPA),A
	LD	A,#C9
MSFLAG	EQU	$-1
	CP	#C9
	RET	NZ
	LD	A,(HL)
	CALL	MODIFICH
	LD	C,A
	LD	A,0
CPA	EQU	$-1
	CALL	MODIFICH
	CP	C
	RET 
;
MODIFICH
	CP	"{"
	RET	NC
	CP	"a"
	RET	C
	SUB	#20
	RET 
;
OUTSL
	LD	A,(FILESOUT1)
	CP	14
	JR	Z,SCR14
	LD	HL,#4000
	CALL	FFF0
	LD	HL,#5700
	CALL	FFF0
	LD	HL,#5040
	CALL	FFF0
	CALL	PRL
	DEFB	22,17,1,#FF,121
	DEFB	"Start:	     Len:      Size:	t:    sec:  "
	DEFB	#FF,71,"",0
	RET 
SCR14
	LD	HL,#4400
	CALL	FFF0
	LD	HL,#4340
	CALL	FFF0
	CALL	PRL
	DEFB	22,1,3,#FF,71
	DEFB	"Name	  Type Start Length "
	DEFB	#FF,66,"Size",#FF,71," Trk Sec",0
	LD	HL,#5420
FFF0
	PUSH	HL
	POP	DE
	INC	DE
	LD	BC,22
	LD	(HL),#FF
	LDIR 
	LD	(HL),#F0
	RET 
;
OUTSR
	LD	A,0
COPY_	EQU	$-1
	OR	A
	JR	Z,NOBRCOPY
	XOR	A
	LD	(COPY_),A
	LD	A,(SDRIVE)
	SUB	"A"
	LD	(#5D19),A
NOBRCOPY
	CALL	PRL
	DEFB	22,0,51,#FF,7,"Drive: ",#FF,71,0
	LD	A,(#5D19)
	ADD	A,"A"
	CALL	PRC
	CALL	PRL
	DEFB	22,1,49,"<",#FF,71,0
	LD	A,(TYPE)
	PUSH	AF
	XOR	A
	LD	(TYPE),A
	LD	HL,NAME
	CALL	PRT
	CALL	PRCSP
	POP	AF
	LD	(TYPE),A
	CALL	PRC
	CALL	PRL
	DEFB	#FF,7,22,1,60,">",22,2,48,"Title:",#FF,71,0
	LD	HL,TITLE
	LD	B,8
	CALL	BPRT
	CALL	PRL
	DEFB	#FF,7
	DEFB	22, 4,47,"Free:"
	DEFB	22, 5,47,"Files:"
	DEFB	22, 6,47,"Deleted:"
	DEFB	22, 7,47,"DeletedSec:"
	DEFB	22, 8,47,"FirstFreeTrk:"
	DEFB	22, 9,47,"FirstFreeSec:"
	DEFB	22,11,47,"MarkedFiles:"
	DEFB	22,12,47,"MarkedSec:"
	DEFB	22,13,47,"SaveMemSec:"
	DEFB	22,14,47,"MemSectors:"
	DEFB	22,16,48,"Overlay:"
	DEFB	22,17,48,"Mark"
	DEFB	22,17,56,"Mask",0
PRTCASEDEL
	CALL	PRL		  
	DEFB	22,6,63,#FF,71,"-",0
PLUSDEL	EQU	$-2
	RET		   
;					
CLS1
	LD	C,31		   
	JR	CLS11		    
CLS0
	LD	C,22		   
CLS11
	LD	DE,0		   
	LD	B,19		   
CLS12
	LD	A,FATTR		      
;					
;DE - YX				
;BC - DYDX				
;A  - ATTR				
;CLS
	PUSH	DE		 
	PUSH	BC		 
	EX	AF,AF'		     
	CALL	SCRADDR		      
	LD	A,B		  
	ADD	A,A		  
	ADD	A,A		  
	ADD	A,A		  
	LD	B,A		  
CLSLP
	PUSH	HL		 
	PUSH	BC		 
	LD	B,0		  
	LD	(HL),B		     
	LD	E,L		  
	LD	D,H		  
	INC	DE		 
	LDIR		    
	POP	BC		 
	POP	HL		 
	CALL	NEXTL		    
	DJNZ	CLSLP		    
	POP	BC		 
	POP	DE		 
	EX	AF,AF'		     
CLRATTR
	LD	(ATTRCLS),A
	CALL	ATTRADDR	       
CLR1
	PUSH	BC		 
	PUSH	HL		 
	LD	B,0		  
	LD	E,L		  
	LD	D,H		  
	INC	DE		 
	LD	(HL),0		     
ATTRCLS	EQU	$-1
	LDIR		    
	POP	HL		 
	LD	C,#20		    
	ADD	HL,BC		    
	POP	BC		 
	DJNZ	CLR1		   
	RET		   
;					
NEXTL
	INC	H		
	LD	A,H		  
	AND	7		
	RET	NZ		 
	LD	A,32		   
	ADD	A,L		  
	LD	L,A		  
	RET	C		
	LD	A,H		  
	SUB	8		
	LD	H,A		  
	RET		   
;					
;D - Y [0..23]				
;E - X [0..31]				
SCRADDR
	LD	A,D		  
	AND	24		 
	ADD	A,#40		    
	LD	H,A		  
	LD	A,D		  
	AND	7		
	RRCA		    
	RRCA		    
	RRCA		    
	ADD	A,E		  
	LD	L,A		  
	RET		   
;					
ATTRADDR
	LD	H,0		  
	LD	L,D		  
	ADD	HL,HL		    
	ADD	HL,HL		    
	ADD	HL,HL		    
	ADD	HL,HL		    
	ADD	HL,HL		    
	LD	A,L		  
	ADD	A,E		  
	LD	L,A		  
	LD	A,#58		    
	ADD	A,H		  
	LD	H,A		  
	RET		   
;					
PRS
	DI		  
	LD	HL,SP40
	LD	DE,SP40+1
	LD	(HL)," "
	LD	BC,39
	LDIR 
	XOR	A
	LD	(DE),A
	LD	HL,WIND0	       
ADWIND1	EQU	$-2
	LD	(CURW0),HL
	LD	A,0		  
FOF	EQU	$-1
	LD	(C_FIL),A		
	CALL	ADFCMS
	PUSH	HL		 
	POP	IX		 
	LD	B,60		   
FILESOUT1 EQU	$-1
PRNEXTL
	PUSH	BC		 
	LD	HL,0		   
CURW0	EQU	$-2
	LD	D,(HL)		     
	INC	HL		 
	LD	E,(HL)		     
	INC	HL		 
	LD	(CURW0),HL
	LD	(AT),DE		      
	CALL	PRL		  
	DEFB	22,0,0,0	       
AT	EQU	$-3
	LD	A,(FILESOUT1)
	CP	60		 
	JR	Z,NOPRTSP		
	LD	HL,ATX		     
	DEC	(HL)		   
	CALL	PRCSP		    
NOPRTSP
	LD	HL,C_FIL	       
	LD	A,(NUMF)	       
	DEC	A		
	CP	(HL)		   
	JR	C,PRSPACE
	LD	IY,TMR		     
	LD	A,(IY)		     
C_FIL	EQU	$-1
	OR	A		
	LD	A,FATTR		      
FILEATTR EQU	$-1
	JR	Z,NOMRED	       
	LD	A,MATTR
NOMRED
	LD	(ATTR),A	       
	PUSH	IX		 
	POP	HL		 
	LD	B,8		  
	CALL	BPRT		   
	PUSH	HL		 
	CALL	PRCSP		    
	POP	HL		 
	LD	B,1		  
	CALL	BPRT		   
	LD	A,(FILESOUT1)
	CP	60		 
	JR	Z,ENDPRS	       
	CALL	PRL		  
	DEFB	"    ",0	       
	LD	L,(IX+9)	       
	LD	H,(IX+10)		
	CALL	PRT_W		    
	CALL	PRCSP		    
	CALL	PRCSP		    
	LD	L,(IX+11)		
	LD	H,(IX+12)		
	CALL	PRT_W		    
	LD	L,(IX+13)		
	CALL	PRT_B5		     
	LD	L,(IX+15)		
	CALL	PRT_B4		     
	LD	L,(IX+14)		
	CALL	PRT_B4		     
	CALL	PRCSP		    
ENDPRS
	LD	BC,16		    
	ADD	IX,BC		    
	LD	HL,C_FIL	       
	INC	(HL)		   
	POP	BC		 
	DEC	B		
	JP	NZ,PRNEXTL
	LD	IY,#5C3A	       
	EI		  
	RET		   
PRSPACE
	LD	A,(FILESOUT1)
	CP	14		 
	LD	HL,SP40		      
	JR	Z,SETSP		      
	LD	HL,SP10		      
SETSP
	LD	A,FATTR		      
	LD	(ATTR),A	       
	CALL	PRT		  
	JR	ENDPRS		     
;					
ADFC000
	LD	BC,#C000
	JR	ADF
ADCF
	LD	A,0
CF	EQU	$-1
ADFCMS
	LD	BC,CMS
ADF
	LD	L,A		  
	LD	H,0		  
	ADD	HL,HL		    
	ADD	HL,HL		    
	ADD	HL,HL		    
	ADD	HL,HL		    
	ADD	HL,BC		    
	XOR	A
	CP	(HL)
	RET		   
;					
UPMAIN
	CALL	UP		 
	JP	SCAN		   
;					
DOWNMAIN
	CALL	DOWN		   
	JP	SCAN		   
;					
LEFTMAIN
	CALL	LEFT		   
	JP	SCAN		   
;					
RIGHTMAIN
	CALL	RIGHT		    
	JP	SCAN		   
;					
UP
	XOR	A		
	LD	HL,CF		    
	CP	(HL)		   
	RET	Z		
	DEC	(HL)		   
	LD	HL,CL		    
	CP	(HL)		   
	JR	NZ,NOFIRSTL
	LD	HL,FOF		     
	DEC	(HL)		   
	LD	A,(FILESOUT1)
	CP	60		 
	JR	Z,GOPRS		      
	CALL	PTR		  
	CALL	SCROLLDN	       
	LD	A,1		  
	LD	(FILESOUT1),A
	CALL	PRS		  
	LD	A,14		   
	LD	(FILESOUT1),A
	JR	ENDUP		    
GOPRS
	CALL	PRS		  
ENDUP
	CALL	PTR		  
	JP	OFI		  
NOFIRSTL
	CALL	PTR		  
	LD	HL,CL		    
	DEC	(HL)		   
	JR	ENDUP		    
;					
DOWN
	LD	A,(NUMF)	       
	DEC	A		
	LD	HL,CF		    
	CP	(HL)		   
	RET	Z		
	INC	(HL)		   
	LD	A,(FILESOUT1)
	DEC	A		
	LD	HL,CL		    
	CP	(HL)		   
	JR	NZ,NOLASTL
	LD	HL,FOF		     
	INC	(HL)		   
	LD	A,(FILESOUT1)
	CP	60		 
	JR	Z,GOPRS		      
	LD	A,(FOF)		      
	PUSH	AF		 
	LD	A,(CF)		     
	LD	(FOF),A		      
	CALL	PTR		  
	CALL	SCROLLUP	       
	LD	A,1		  
	LD	(FILESOUT1),A
	LD	HL,WIND11		
	LD	(ADWIND1),HL
	CALL	PRS		  
	LD	HL,WIND1	       
	LD	(ADWIND1),HL
	LD	A,14		   
	LD	(FILESOUT1),A
	POP	AF		 
	LD	(FOF),A		      
	JR	ENDUP		    
NOLASTL
	CALL	PTR		  
	LD	HL,CL		    
	INC	(HL)		   
	JR	ENDUP		    
;					
LEFT
	XOR	A		
	LD	HL,CF		    
	CP	(HL)		   
	RET	Z		
	CALL	PTR		  
	LD	HL,CF		    
	LD	A,(CL)		     
	LD	E,15
FILES1	EQU	$-1
	SUB	E
	JR	NC,NOFIRSTST
	LD	A,(FOF)		      
	SUB	E
	JR	C,NO13FILS
	LD	(FOF),A		      
	LD	A,(HL)		     
	SUB	E
	LD	(HL),A		     
	JR	PRSCORR		      
NO13FILS
	LD	A,(FOF)		      
	PUSH	AF		 
	XOR	A		
	LD	(CL),A
	LD	(CF),A		     
	LD	(FOF),A		      
	POP	AF		 
	CP	0		
	JP	Z,ENDUP		      
PRSCORR
	CALL	PRS		  
	JR	ENDUP22		      
NOFIRSTST
	LD	(CL),A		     
	LD	A,(HL)		     
	SUB	E
	LD	(HL),A		     
ENDUP22
	JP	ENDUP		    
;					
RIGHT
	LD	A,(NUMF)	       
	LD	HL,CF		    
	DEC	A		
	CP	(HL)		   
	RET	Z		
	CALL	PTR		  
	LD	HL,CF		    
	LD	A,(CL)		     
	LD	DE,(FILES1)
	ADD	A,E
	LD	(CL),A		     
	LD	A,E
	ADD	A,(HL)		     
	LD	(HL),A		     
	LD	HL,NUMF		      
	CP	(HL)		   
	JR	C,NOLAST	       
	LD	A,(FOF)		      
	SUB	(HL)		   
	NEG		   
	DEC	A		
	LD	(CL),A		     
	LD	A,(NUMF)	       
	DEC	A		
	LD	(CF),A		     
NOLAST
	LD	A,(FILESOUT1)
	DEC	A		
	LD	HL,CL		    
	CP	(HL)		   
	JP	NC,ENDUP	       
	LD	A,(HL)		     
	SUB	E
	LD	(HL),A		     
	LD	A,(FOF)		      
	ADD	A,E
	LD	(FOF),A		      
	JP	GOPRS		    
;					
SCROLLUP
	LD	HL,#4061	       
	LD	E,L		  
	LD	D,H		  
	LD	B,13		   
LOOPSU
	PUSH	BC		 
	CALL	FORWLINE	       
	CALL	COPYLINE	       
	EX	DE,HL		    
	CALL	FORWLINE	       
	EX	DE,HL		    
	POP	BC		 
	DJNZ	LOOPSU		     
	LD	HL,#5861	       
	LD	B,13		   
LPATTUP
	PUSH	BC		 
	LD	E,L		  
	LD	D,H		  
	LD	BC,32		    
	ADD	HL,BC		    
	PUSH	HL		 
	LD	BC,21		    
	LDIR		    
	POP	HL		 
	POP	BC		 
	DJNZ	LPATTUP		      
	RET		   
;					
SCROLLDN
	LD	HL,#5001	       
	LD	E,L		  
	LD	D,H		  
	LD	B,13		   
LOOPSD
	PUSH	BC		 
	CALL	BACKLINE	       
	CALL	COPYLINE	       
	EX	DE,HL		    
	CALL	BACKLINE	       
	EX	DE,HL		    
	POP	BC		 
	DJNZ	LOOPSD		     
	LD	HL,#5A01	       
	LD	B,13		   
LPATTDN
	PUSH	BC		 
	LD	E,L		  
	LD	D,H		  
	LD	BC,32		    
	OR	A		
	SBC	HL,BC		    
	PUSH	HL		 
	LD	BC,21		    
	LDIR		    
	POP	HL		 
	POP	BC		 
	DJNZ	LPATTDN		      
	RET		   
;					
COPYLINE
	PUSH	HL		 
	PUSH	DE		 
	LD	B,8		  
LOOPCL
	PUSH	HL		 
	PUSH	DE		 
	PUSH	BC		 
	LD	BC,20		    
	LDIR		    
	POP	BC		 
	POP	DE		 
	POP	HL		 
	INC	D		
	INC	H		
	DJNZ	LOOPCL		     
	POP	DE		 
	POP	HL		 
	RET		   
;					
FORWLINE
	LD	A,L		  
	ADD	A,32		   
	LD	L,A		  
	RET	NC		 
	LD	A,H		  
	ADD	A,8		  
	LD	H,A		  
	RET		   
;					
BACKLINE
	LD	A,L		  
	SUB	32		 
	LD	L,A		  
	RET	NC		 
	LD	A,H		  
	SUB	8		
	LD	H,A		  
	RET		   
;					
PTR
	CALL	COORDLINE		
	LD	A,(FILESOUT1)
	CP	60		 
	LD	B,10		   
	JR	Z,INV		    
	LD	HL,ATX		     
	DEC	(HL)		   
	LD	B,41		   
INV
	PUSH	BC		 
	CALL	CURS2		    
	POP	BC		 
	LD	HL,ATX		     
	INC	(HL)		   
	DJNZ	INV		  
	RET		   
;					
COORDLINE
	LD	A,0		  
CL	EQU	$-1
	ADD	A,A		  
	LD	C,A		  
	LD	B,0		  
	LD	HL,(ADWIND1)
	ADD	HL,BC		    
	LD	D,(HL)		     
	INC	HL		 
	LD	E,(HL)		     
	LD	(ATCURS),DE
	LD	HL,CURSXY		
	JP	PRT		  
;					
OFI
	DEFB	0		
	LD	A,"#"		    
	LD	(SPACECH),A
	CALL	PRL		  
	DEFB	22,17,7,#FF,120,0
	CALL	ADCF
	PUSH	HL		 
	POP	IX		 
	LD	L,(IX+9)	       
	LD	H,(IX+10)		
	CALL	PRT_W_L		      
	LD	A,17		   
	LD	(ATX),A		      
	LD	L,(IX+11)		
	LD	H,(IX+12)		
	CALL	PRT_W_L		      
	LD	A,28		   
	LD	(ATX),A		      
	LD	L,(IX+13)		
	LD	A,122		    
	LD	(ATTR),A	       
	CALL	PRT_B_L		      
	LD	A,120		    
	LD	(ATTR),A	       
	LD	A,34		   
	LD	(ATX),A		      
	LD	L,(IX+15)		
	CALL	PRT_B_L		      
	LD	A,42		   
	LD	(ATX),A		      
	LD	L,(IX+14)		
	LD	H,0		  
	LD	A,2		  
	CALL	PRNUML		     
	JP	SETSPCH		      
;					
ODI
	LD	IX,CAT+#900
	CALL	PRL		  
	DEFB	22,4,58,#FF,71,0
	LD	L,(IX-27)		
	LD	H,(IX-26)		
	CALL	PRT_W		    
	CALL	PRL		  
	DEFB	22,5,60,0		
	LD	A,(IX-28)		
	SUB	(IX-12)		      
	LD	L,A		  
	CALL	PRT_B		    
	CALL	PRL		  
	DEFB	22,6,60,0		
	LD	L,(IX-12)		
	CALL	PRT_B		    
	CALL	PRL		  
	DEFB	22,7,58,0		
	LD	HL,0		   
DELSEC	EQU	$-2
	CALL	PRT_W		    
	CALL	PRL
	DEFB	22,8,60,0		
	LD	L,(IX-30)		
	CALL	PRT_B		    
	CALL	PRL		  
	DEFB	22,9,60,0		
	LD	L,(IX-31)		
	JP	PRT_B		    
;					
OMI
	CALL	PRL		  
	DEFB	22,11,60,#FF,71,0
	LD	HL,0		   
MREDF	EQU	$-2
	XOR	A		
	CP	L		
	LD	A,71		   
	JR	Z,SETMRATT
	LD	A,MATTR
SETMRATT
	LD	(ATTR),A	       
	CALL	PRT_B		    
	CALL	PRL		  
	DEFB	22,12,58,0
	LD	HL,0		   
MREDS	EQU	$-2
	CALL	PRT_W		    
OSMS
	CALL	PRL		  
	DEFB	22,13,58,#FF,71,0
	LD	HL,0		   
SAVEMEMSEC EQU	$-2
	CALL	PRT_W		    
	CALL	PRL		  
	DEFB	22,14,58,0
	LD	HL,0
MEMSECTORS EQU	$-2
	JP	PRT_W		    
;					
OSI
	LD	A,71		   
	LD	(ATTR),A	       
	LD	HL,MSG_HELP
DIPOVERLAY EQU	$-2
	CALL	PRT		  
	CALL	PRL
	DEFB	22,17,52,":",0
	LD	A,(SORT)	       
	CALL	PRTMODE		      
	CALL	PRL		  
	DEFB	22,17,60,":",0
	LD	A,(MSFLAG)
PRTMODE
	OR	A		
	LD	A,"E"		    
	JR	NZ,PRTMD	       
	LD	A,"N"		    
PRTMD
	JP	PRC		  
;					
CLRSCR
	LD	HL,#4000	       
CLRSCR2
	PUSH	HL
	POP	DE
	INC	DE
	LD	(HL),L		     
	LD	BC,6144		      
	LDIR		    
	LD	(HL),A		     
	LD	BC,767		     
	LDIR		    
	RET		   
;					
	INCLUDE	"BIOS",#81
	INCLUDE	"COPY",#82
	INCLUDE	"UNITS",#83
	INCLUDE	"DATA",#84
	INCLUDE	"OVERLAY",#85
;
OVERLAYL EQU	$-OVERLAY
OVERLAYE EQU	$-1
PRGSAVE	 EQU	PRGLEN+OVERLAYL
PRGSIZE	 EQU	$-#6000
;
_LENSAVE=PRGSAVE
_OVRLEN=OVERLAYL
_OVREND=OVERLAYE
_OVR=OVERLAY
_END=PRGEND